#ifndef	lint
static char sccsid[] = "@(#)dump.c	1.1 4/23/94 SyddWare";
#endif
/*****************************************************************************
* Project:         SyddWare
*
* Module Name:     dump.c
*
* Description:     This routine is a debug aid that dumps the contents of an
*                  area of memory in hex and ASCII.
*
* Arguments:       stat = dump(buffer,num,file);
*  Name             Type     I/O  Description
*  ---------------  -------  ---  --------------------------------------
*  stat             int       O   Always TRUE
*  buffer           char *    I   The address of the buffer to be dumped.
*  num              int       I   The number of characters to dump.
*  file             FILE *    I   The FILE ptr to which the output is to
*                                  go (if NULLF, set to stdout).
*
* Returns:         TRUE
*
* Revision History
*   DATE    S/W ENGINEER  DESCRIPTION OF WORK
* --------  ------------  ---------------------------------------------------
*
******************************************************************************/
#include "generi_.h"
#ifdef	DEBUG
#undef	DEBUG
#endif

extern char *sys_errlist[];

int    dump(buffer,num,file)
   unsigned    char    buffer[];
   int     num;
   FILE    *file;
{
   int     icnt,jcnt;

   if (!file) file = stdout;
#ifdef __STDC__
   fprintf(file,"\nDump of %d bytes at memory location %p,e=%d[%s]\n",
	 num,&buffer[0],errno,sys_errlist[errno]);
#else
   fprintf(file,"\nDump of %d bytes at memory location 0x%lx,e=%d[%s]\n",
	 num,&buffer[0],errno,sys_errlist[errno]);
#endif /* __STDC__ */
   fprintf(file,"         Hex                                                  \
ASCII\n");
   fprintf(file,"         -----------------------------------------------      \
----------------");

   for (icnt=0;icnt<num;icnt+=16)
   {
#ifdef __STDC__
       fprintf(file,"\n%p ",&buffer[icnt]);
#else
       fprintf(file,"\n%09.9lx ",&buffer[icnt]);
#endif /* __STDC__ */
       for (jcnt=icnt;jcnt<icnt+16;++jcnt)
       {
           if (jcnt < num)
			{
#ifdef __STDC__
               fprintf(file,"%02hX ",buffer[jcnt]);
#else
               fprintf(file,"%02.2x ",buffer[jcnt]);
#endif /* __STDC__ */
			}
           else 
               fprintf(file,"   ");
       }
       fprintf(file,"  |  ");
       for (jcnt=icnt;jcnt<icnt+16;++jcnt)
       {
           if (jcnt < num) 
           {
               if (buffer[jcnt] > 31 && buffer[jcnt] < 127)
                   fprintf(file,"%c",buffer[jcnt]);
               else 
                   fprintf(file,".");
           }
           else 
               fprintf(file," ");
       }
   }
   fprintf(file,"\n");
   return(TRUE);
}
